<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * if hook execution is enabled this function will be executed
 * when publishing a document, template, object or class
 * The array $param has all information about the respective document.
 *
 * IMPORTANT!
 * Copy this file to the custom/hooks folder when doing any changes
 * Files in the sample_hooks folder are not executed and are not update-safe and will be overwritten by the next webEdition update
 *
 *
 */
class we_hook_customer_Login extends we_hook_base{
	protected $customer; //contains $_SESSION['webuser'] data

	/** @var string */
	protected $type;

	/**
	 *
	 * @param we_hook_handler $handler
	 * @param array{type:string,customer:array} $params
	 */
	public function __construct(we_hook_handler $handler, array $params){
		parent::__construct($handler, $params);
		$this->customer = &$this->param['customer'];
		$this->type = $this->param['type'];
	}

	public function execute(): bool{
		switch($this->type){
			case 'normal':
			case 'autoLogin':
		}
		return true;
	}

}
