<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
define('WE_DOCUMENT_ROOT', (string) realpath(__DIR__ . '/../'));
if(!defined('NO_SESS')){
	define('NO_SESS', 1);
}
define('SCHEDULED_BY_CRON', 1);
//in case scheduled documents use SERVER vars, so set it in advance
if(empty($_SERVER['DOCUMENT' . '_ROOT'])){
	$_SERVER['DOCUMENT' . '_ROOT'] = WE_DOCUMENT_ROOT;
	$_SERVER['SERVER_NAME'] = 'undefined';
}

require_once('we/include/we.inc.php');
//remove all parameters in case some functions might hear to them
unset($_REQUEST, $_GET, $_POST, $_COOKIE);

if(we_modules_info::isActive(we_modules_info::SCHEDULER)){
	we_schedule_scheduler::trigger_schedule();
}
if(we_modules_info::isActive(we_modules_info::WORKFLOW)){
	echo we_workflow_utility::forceOverdueDocuments();
}
//clean old sessions
we_base_sessionHandler::cleanSessions();

we_base_file::cleanTempFiles();
