<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: acac0a418617 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-03 18:53 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * class    perm
 * @desc    This class holds all permission consts
 *
 */
abstract class we_base_perm{
	//admin
	/** Admin permission */
	public const ADMINISTRATOR = 'ADMINISTRATOR';
	//controlpermissions
	public const USER_CHANGE_DOCUMENT_OWNER = 'CHANGE_DOCUMENT_OWNER';
	public const USER_CHANGE_DOCUMENT_PERMISSION = 'CHANGE_DOCUMENT_PERMISSION';
	public const USER_DELETE = 'DELETE_USER';
	public const USER_EDIT_PASSWD = 'EDIT_PASSWD';
	public const USER_EDIT_SETTINGS = 'EDIT_SETTINGS';
	public const USER_GROUP_DELETE = 'DELETE_GROUP';
	public const USER_GROUP_NEW = 'NEW_GROUP';
	public const USER_GROUP_SAVE = 'SAVE_GROUP';
	public const USER_NEW = 'NEW_USER';
	public const USER_SAVE = 'SAVE_USER';
//widgets
	public const WIDGET_EDIT_MFD = 'EDIT_MFD_USER';
	public const WIDGET_SHOW_USR = 'WIDGET_SHOW_USR';
	//customer
	public const CUSTOMER_AUTOLOGINID_VISIBLE = 'CUSTOMER_AUTOLOGINID_VISIBLE';
	public const CUSTOMER_CAN_CHANGE_DOCS = 'CAN_CHANGE_DOCS_CUSTOMER';
	public const CUSTOMER_CAN_EDIT_CUSTOMERFILTER = 'CAN_EDIT_CUSTOMERFILTER';
	public const CUSTOMER_CHANGE_ENCRYPTED_FIELD = 'CUSTOMER_CHANGE_ENCRYPTED_FIELD';
	public const CUSTOMER_DECRYPT_FIELD = 'CUSTOMER_DECRYPT_FIELD';
	public const CUSTOMER_DELETE = 'DELETE_CUSTOMER';
	public const CUSTOMER_EDIT = 'EDIT_CUSTOMER';
	public const CUSTOMER_NEW = 'NEW_CUSTOMER';
	public const CUSTOMER__SHOW_ADMIN = 'SHOW_CUSTOMER_ADMIN';
	//glossary
	public const GLOSSARY_DELETE = 'DELETE_GLOSSARY';
	public const GLOSSARY_EDIT = 'EDIT_GLOSSARY';
	public const GLOSSARY_EDIT_DICTIONARY = 'EDIT_GLOSSARY_DICTIONARY';
	public const GLOSSARY_NEW = 'NEW_GLOSSARY';
	//importExportpermissions
	public const EXIM_BACKUPLOG = 'BACKUPLOG';
	public const EXIM_EXPORT = 'EXPORT';
	public const EXIM_EXPORTNODOWNLOAD = 'EXPORTNODOWNLOAD';
	public const EXIM_EXPORT_CSV = 'CSV_EXPORT';
	public const EXIM_EXPORT_DELETE = 'DELETE_EXPORT';
	public const EXIM_EXPORT_EDIT = 'EDIT_EXPORT';
	public const EXIM_EXPORT_GENERICXML = 'GENERICXML_EXPORT';
	public const EXIM_EXPORT_MAKE = 'MAKE_EXPORT';
	public const EXIM_EXPORT_NEW = 'NEW_EXPORT';
	public const EXIM_IMPORT = 'IMPORT';
	public const EXIM_IMPORT_CSV = 'CSV_IMPORT';
	public const EXIM_IMPORT_FILE = 'FILE_IMPORT';
	public const EXIM_IMPORT_GENERICXML = 'GENERICXML_IMPORT';
	public const EXIM_IMPORT_SITE = 'SITE_IMPORT';
	public const EXIM_IMPORT_WXML = 'WXML_IMPORT';
	//navigation
	public const NAVIAGTION_EDIT_RULES = 'EDIT_NAVIAGTION_RULES';
	public const NAVIGATION_DELETE = 'DELETE_NAVIGATION';
	public const NAVIGATION_EDIT = 'EDIT_NAVIGATION';
	public const NAVIGATION_EDIT_DYNAMIC = 'EDIT_DYNAMIC_NAVIGATION';
	//newsletter
	public const NEWSLETTER_DELETE = 'DELETE_NEWSLETTER';
	public const NEWSLETTER_EDIT = 'EDIT_NEWSLETTER';
	public const NEWSLETTER_FILES = 'NEWSLETTER_FILES';
	public const NEWSLETTER_NEW = 'NEW_NEWSLETTER';
	public const NEWSLETTER_SEND = 'SEND_NEWSLETTER';
	public const NEWSLETTER_SEND_TEST_EMAIL = 'SEND_TEST_EMAIL';
	public const NEWSLETTER_SETTINGS = 'NEWSLETTER_SETTINGS';
	//object
	public const OBJECTFILES_CAN_SEE = 'CAN_SEE_OBJECTFILES';
	public const OBJECTFILE_DELETE = 'DELETE_OBJECTFILE';
	public const OBJECTFILE_MOVE = 'MOVE_OBJECTFILE';
	public const OBJECTFILE_NEW = 'NEW_OBJECTFILE';
	public const OBJECTFILE_NEW_FOLDER = 'NEW_OBJECTFILE_FOLDER';
	public const OBJECTS_CAN_COPY = 'CAN_COPY_OBJECTS';
	public const OBJECTS_CAN_SEE = 'CAN_SEE_OBJECTS';
	public const OBJECTS_CAN_SELECT_OTHER_USERS = 'CAN_SELECT_OTHER_USERS_OBJECTS';
	public const OBJECT_DELETE = 'DELETE_OBJECT';
	public const OBJECT_NEW = 'NEW_OBJECT';
	//rebuildpermissions
	public const REBUILD = 'REBUILD';
	public const REBUILD_ALL = 'REBUILD_ALL';
	public const REBUILD_TEMPLATES = 'REBUILD_TEMPLATES';
	public const REBUILD_FILTERD = 'REBUILD_FILTERD';
	public const REBUILD_OBJECTS = 'REBUILD_OBJECTS';
	public const REBUILD_INDEX = 'REBUILD_INDEX';
	public const REBUILD_THUMBS = 'REBUILD_THUMBS';
	//public const REBUILD_NAVIGATION = 'REBUILD_NAVIGATION';
	public const REBUILD_META = 'REBUILD_META';
	//scheduler
	public const SCHEDULER_CAN_SEE = 'CAN_SEE_SCHEDULER';
	//SEEM
	public const SEEM_CAN_SEE_MENUE = 'CAN_SEE_MENUE';
	public const SEEM_CAN_WORK_NORMAL_MODE = 'CAN_WORK_NORMAL_MODE';
	public const SEEM_CHANGE_START_DOCUMENT = 'CHANGE_START_DOCUMENT';
	//shop
	public const SHOP_DELETE_ARTICLE = 'DELETE_SHOP_ARTICLE';
	public const SHOP_DELETE_ORDER = 'DELETE_SHOP_ORDER';
	public const SHOP_EDIT_ORDER = 'EDIT_SHOP_ORDER';
	public const SHOP_EDIT_PREFS = 'EDIT_SHOP_PREFS';
	public const SHOP_NEW_ARTICLE = 'NEW_SHOP_ARTICLE';
	//FIXME this should not be shop specific anymore
	public const VARIANTS_CAN_EDIT = 'CAN_EDIT_VARIANTS';
	//upload
	public const UPLOAD_DISABLE_SIZE_LIMIT = 'UPLOAD_NOSIZE';
	public const UPLOAD_DISABLE_DIM_LIMIT='UPLOAD_NODIM';
	//versions
	public const VERSIONS_CAN_SEE = 'SEE_VERSIONS';
	public const VERSIONS_RESET = 'RESET_VERSIONS';
	//voting
	public const VOTING_DELETE = 'DELETE_VOTING';
	public const VOTING_EDIT = 'EDIT_VOTING';
	public const VOTING_NEW = 'NEW_VOTING';
	//workflow
	public const WORKFLOW_DELETE = 'DELETE_WORKFLOW';
	public const WORKFLOW_EDIT = 'EDIT_WORKFLOW';
	public const WORKFLOW_EMPTY_LOG = 'EMPTY_LOG';
	public const WORKFLOW_NEW = 'NEW_WORKFLOW';
	//workpermissions
	public const WORK_ACCESSIBLE_PARAMETERS_CAN_SEE = 'CAN_SEE_ACCESSIBLE_PARAMETERS';
	public const WORK_BROWSE_SERVER = 'BROWSE_SERVER';
	// User can publish docs/obj
	public const WORK_CAN_PUBLISH = 'PUBLISH';
	public const WORK_CATEGORY_EDIT = 'EDIT_KATEGORIE';
	public const WORK_COLLECTIONS_CAN_SEE = 'CAN_SEE_COLLECTIONS';
	public const WORK_COLLECTION_DELETE = 'DELETE_COLLECTION';
	public const WORK_COLLECTION_FOLDER_DELETE = 'DELETE_COLLECTION_FOLDER';
	public const WORK_COLLECTION_FOLDER_NEW = 'NEW_COLLECTION_FOLDER';
	public const WORK_COLLECTION_MOVE = 'MOVE_COLLECTION';
	public const WORK_COLLECTION_NEW = 'NEW_COLLECTION';
	public const WORK_COLLECTION_SAVE = 'SAVE_COLLECTION';
	public const WORK_CSS_NEW = 'NEW_CSS';
	public const WORK_DOCEXTENSION_EDIT = 'EDIT_DOCEXTENSION';
	public const WORK_DOCTYPE_EDIT = 'EDIT_DOCTYPE';
	public const WORK_DOCUMENTS_CAN_SEE = 'CAN_SEE_DOCUMENTS';
	public const WORK_DOCUMENT_DELETE = 'DELETE_DOCUMENT';
	public const WORK_DOCUMENT_FOLDER_DELETE = 'DELETE_DOC_FOLDER';
	public const WORK_DOCUMENT_FOLDER_NEW = 'NEW_DOC_FOLDER';
	public const WORK_DOCUMENT_FOLDER_PATH_CHANGE = 'CHANGE_DOC_FOLDER_PATH';
	public const WORK_DOCUMENT_MOVE = 'MOVE_DOCUMENT';
	public const WORK_DOCUMENT_NO_DOCTYPE_ALLOWED = 'NO_DOCTYPE';
	public const WORK_DOCUMENT_SAVE_ALLOWED = 'SAVE_DOCUMENT_TEMPLATE';
	public const WORK_DOCUMENT_WEBEDITION_NEW = 'NEW_WEBEDITIONSITE';
	public const WORK_EXTERNAL_FILES_CAN_SELECT = 'CAN_SELECT_EXTERNAL_FILES';
	public const WORK_FOLDERS_COPY = 'CAN_COPY_FOLDERS';
	public const WORK_FORMMAIL_SHOW = 'FORMMAIL';
	public const WORK_HTACCESS_NEW = 'NEW_HTACCESS';
	public const WORK_HTML_NEW = 'NEW_HTML';
	public const WORK_IMAGE_NEW = 'NEW_GRAFIK';
	public const WORK_INFOTAB_CAN_SEE = 'CAN_SEE_INFO';
	public const WORK_JS_NEW = 'NEW_JS';
	public const WORK_METADATAFIELD_EDIT = 'EDIT_METADATAFIELD';
	public const WORK_OTHER_NEW = 'NEW_SONSTIGE';
	public const WORK_PROPERTIES_CAN_SEE = 'CAN_SEE_PROPERTIES';
	public const WORK_QUICKSTART_CAN_SEE = 'CAN_SEE_QUICKSTART';
	public const WORK_TEMPLATES_CAN_SEE = 'CAN_SEE_TEMPLATES';
	public const WORK_TEMPLATES_FOLDER_NEW = 'NEW_TEMP_FOLDER';
	public const WORK_TEMPLATE_DELETE = 'DELETE_TEMPLATE';
	public const WORK_TEMPLATE_MOVE = 'MOVE_TEMPLATE';
	public const WORK_TEMPLATE_NEW = 'NEW_TEMPLATE';
	public const WORK_TEMP_FOLDER_DELETE = 'DELETE_TEMP_FOLDER';
	public const WORK_TEXT_NEW = 'NEW_TEXT';
	public const WORK_VALIDATION_CAN_SEE = 'CAN_SEE_VALIDATION';
	public const WORK_VALIDATION_EDIT = 'CAN_EDIT_VALIDATION';
	public const WORK_VIDEO_NEW = 'NEW_FLASH';
	public const WORK_WORKSPACE_CAN_SELECT_OTHER_FILES = 'CAN_SELECT_OTHER_USERS_FILES';

}
