<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: a980ca57c9e6 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-04 20:53 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_showTempDocumentData extends we_editor_base{
	/** @var string */
	private $file;

	/** @var bool */
	private $del = false;

	public function setContent(string $content): self{
		$this->file = we_base_file::saveTemp($content);
		$this->del = true;
		return $this;
	}

	public function setFile(string $file): self{
		$this->file = $file;
		return $this;
	}

	public function show(): string{
		if(!$this->file || !file_exists($this->file)){
			return 'file not found: ' . $this->file;
		}
		ob_start();
		include($this->file);
		if($this->del){
			we_base_file::deleteLocalFile($this->file);
		}
		return ob_get_clean() ?: '';
	}

}
