<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 775cad6a0ea0 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-04-24 01:26 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_gui_cmd implements we_interface_cmd{

	public static function we_cmd(string $cmd): bool{
		switch($cmd){
			case 'we_gui_loggingOut':
				we_base_session::loggingOut();
				return true;
			case 'we_gui_logout':
				we_base_session::logout();
				return true;
			case 'we_gui_changePasswd':
				we_users_changePassword::showDialog();
				return true;
			case 'we_gui_openTagWizzard':
				echo we_gui_tagWizzard::getHTML();
				return true;
			case 'we_gui_phpinfo':
			case 'we_gui_sysinfo':
				we_dialog_sysinfo::getDialog($cmd);
				return true;
			case 'we_gui_showerrorlog':
				we_html_tools::protect([we_base_perm::ADMINISTRATOR]);
				we_dialog_errorlog::getDialog();
				return true;
			case 'we_gui_openExtDoc_footer':
				echo we_gui_SEEM::getExtDocFooter();
				return true;
			case 'we_gui_openExtDoc_header':
				echo we_gui_SEEM::getExtDocHeader();
				return true;
			case 'we_gui_openExtDoc_content':
				echo we_gui_SEEM::getExtDocContent();
				return true;
			case 'we_gui_infoDialog':
				we_dialog_info::getFullDialog();
				return true;
			case 'we_gui_openPreferences':
				we_base_preferences::showFrameSet();
				return true;
			case 'we_gui_editorPreferences':
				we_editor_preferences::show();
				return true;
			case 'we_gui_showFormmailLog':
				we_html_tools::protect([we_base_perm::ADMINISTRATOR]);
				we_dialog_formmailLog::getDialog();
				return true;
			case 'we_gui_showFormmailBlockLog':
				we_html_tools::protect([we_base_perm::ADMINISTRATOR]);
				we_dialog_formmailBlockLog::getDialog();
				return true;
			case 'we_gui_loadEditFooter':
			case 'we_gui_reloadEditFooter':
				we_editor_footer::show();
				return true;
			case 'we_gui_loadEditHeader':
			case 'we_gui_reloadEditHeader':
				we_editor_header::show();
				return true;
			case 'we_gui_showMessageConsole':
				we_dialog_messageConsole::getDialog();
				return true;
		}
		return false;
	}

}
