<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 70092ee5fb16 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-02-15 17:30 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_gui_menu{

	/** @var array<int|string,we_gui_menuEntry> */
	private $entries;

	/**
	 * @param we_gui_menuTop[] $entries
	 */
	public function __construct(array $entries){
		$this->entries = $entries;
	}

	public function getCode(): string{
		return $this->getHTML();
	}

	public function getHTML(): string{
		$out = '';

		foreach($this->entries as $e){
			$out .= $e->getCode();
		}
		return we_html_element::ul(['id' => 'nav'], $out);
	}

}
