<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: f2ecbbdaa6bb $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-01-26 23:24 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_html_multiIconBoxContent implements Countable{
	/** @var we_html_multiIconBoxContentLine[] */
	private $data = [];

	public function add(?we_html_multiIconBoxContentLine $line): self{
		if($line){
			$this->data[] = $line;
		}
		return $this;
	}

	public function append(we_html_multiIconBoxContent $content): self{
		$this->data = array_merge($this->data, $content->data);
		return $this;
	}

	/**
	 * @return we_html_multiIconBoxContentLine[]
	 */
	public function getContent(): array{
		return $this->data;
	}

	public function isEmpty(): bool{
		return empty($this->data);
	}

	public function count(): int{
		return count($this->data);
	}

}
