<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 5118dfb85839 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-02-13 18:24 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_navigation_menu{

	public static function getMenu(): we_gui_menu{
		return new we_gui_menu([
					(new we_gui_menuTop(g_l('navigation', '[menu_new]'), 'fa fa-plus-circle'))
					->set([
						new we_gui_menuEntry(g_l('navigation', '[entry]'), ['we_navigation_new'], [we_base_perm::NAVIGATION_EDIT]),
						new we_gui_menuEntry(g_l('navigation', '[group]'), ['we_navigation_new_group'], [we_base_perm::NAVIGATION_EDIT]),
					]),
					(new we_gui_menuTop(g_l('navigation', '[navigation]'), 'fa fa-compass'))
					->set([
						new we_gui_menuEntry(g_l('navigation', '[menu_save]'), ['we_navigation_save'], [we_base_perm::NAVIGATION_EDIT]),
						new we_gui_menuEntry(g_l('navigation', '[menu_delete]'), ['we_navigation_delete'], [we_base_perm::NAVIGATION_DELETE, we_base_perm::NAVIGATION_EDIT]),
						new we_gui_menuSeparator(),
						new we_gui_menuEntry(g_l('navigation', '[menu_exit]'), ['we_navigation_exit']),
					]),
					(new we_gui_menuTop(g_l('navigation', '[menu_options]'), 'fa fa-cog', [we_base_perm::NAVIAGTION_EDIT_RULES]))
					->set([
						new we_gui_menuEntry(g_l('navigation', '[menu_highlight_rules]'), ['we_navigation_rules'], [we_base_perm::NAVIAGTION_EDIT_RULES]),
						new we_gui_menuEntry(g_l('menu_global', '[clear_cache]'), ['we_navigation_clear_cache'], [we_base_perm::NAVIGATION_EDIT]),
						new we_gui_menuEntry(g_l('navigation', '[reset_customer_filter]'), ['we_navigation_reset_customer_filter'], [we_base_perm::ADMINISTRATOR], !we_modules_info::isActive(we_modules_info::CUSTOMER))
					])
		]);
	}

}
