<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 5118dfb85839 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-02-13 18:24 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_search_menu{

	public static function getMenu(): we_gui_menu{
		return new we_gui_menu([
					(new we_gui_menuTop(g_l('searchtool', '[menu_new]'), 'fa fa-plus-circle'))
					->set([
						new we_gui_menuEntry(g_l('searchtool', '[forDocuments]'), ['weSearch_new_forDocuments'], [we_base_perm::WORK_DOCUMENTS_CAN_SEE]),
						new we_gui_menuEntry(g_l('searchtool', '[forTemplates]'), ['weSearch_new_forTemplates'], [we_base_perm::WORK_TEMPLATES_CAN_SEE]),
						new we_gui_menuEntry(g_l('searchtool', '[forObjects]'), ['weSearch_new_forObjects'], [we_base_perm::OBJECTFILES_CAN_SEE]),
						new we_gui_menuEntry(g_l('searchtool', '[forMedia]'), ['weSearch_new_forMedia']),
						new we_gui_menuEntry(g_l('searchtool', '[menu_advSearch]'), ['weSearch_new_advSearch'], [we_base_perm::ADMINISTRATOR]),
					]),
					(new we_gui_menuTop(g_l('searchtool', '[menu_suche]'), 'fa fa-search'))
					->set([
						new we_gui_menuEntry(g_l('searchtool', '[menu_save]'), ['weSearch_save']),
						new we_gui_menuEntry(g_l('searchtool', '[menu_delete]'), ['weSearch_delete']),
						new we_gui_menuSeparator(),
						new we_gui_menuEntry(g_l('searchtool', '[menu_exit]'), ['weSearch_exit']),
					])
		]);
	}

}
