<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: b100ecd564da $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-02-04 22:32 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_orderitem extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		return '<?php ' . (strpos($content, '$lv') !== false ? 'global $lv;' : '') .
			'if(' . we_weTag_parser::printTag('orderitem', $attribs) . '){?>' . $content . '<?php }
		we_tag_listview::post(); ?>';
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{

		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return false;
		}

		$condition = self::getAttribute('condition', $attribs, 0, we_base_request::RAW);
		$we_orderitemid = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$hidedirindex = self::getAttribute('hidedirindex', $attribs, TAGLINKS_DIRECTORYINDEX_HIDE, we_base_request::BOOL);
		$condition = ($condition ? $condition . ' AND ' : '') . 'IntID=' . $we_orderitemid;
		$id = $we_orderitemid ?: we_base_request::int('we_orderitemid', 0);

		if($id){
			$lv = new we_listview_shopOrderitem('', 1, 0, '', false, '(IntID=' . intval($id) . ')' . ($condition ? ' AND ' . $condition : ''), 0, 0, 0, $hidedirindex);
			we_tag_listview::pre($lv);
			return we_tag_listview::$current->next_record();
		}

		we_tag_listview::pre(new we_listview_pseudo());
		return false;
	}

}
