<?php
declare(strict_types=1);

/**
 * //NOTE you are inside the constructor of we_weTag_base.class.php
 * webEdition CMS
 *
 * $Rev: 4e4ff85098e9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-03 00:26 +0200 $
 */
class we_tw_ifContentType extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);

		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true);


		$this->Attributes = [
			new we_weTag_choiceAttribute('match', [
				new we_weTag_option(we_base_ContentTypes::WEDOCUMENT),
				new we_weTag_option(we_base_ContentTypes::IMAGE),
				new we_weTag_option(we_base_ContentTypes::HTML),
				new we_weTag_option(we_base_ContentTypes::TEXT),
				new we_weTag_option(we_base_ContentTypes::XML),
				new we_weTag_option(we_base_ContentTypes::JS),
				new we_weTag_option(we_base_ContentTypes::CSS),
				new we_weTag_option(we_base_ContentTypes::APPLICATION),
				new we_weTag_option(we_base_ContentTypes::PDF),
				new we_weTag_option(we_base_ContentTypes::VIDEO),
				new we_weTag_option(we_base_ContentTypes::AUDIO),
				], true, true, '')
		];
	}

}
