<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e4301c9e291b $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-11-13 12:33 +0100 $
 */
class we_tw_ifRegisteredUser extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Module = we_modules_info::CUSTOMER;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$this->Attributes = [
			new we_weTag_sqlColAttribute('permission', CUSTOMER_TABLE, false, [], we_modules_info::CUSTOMER),
			new we_weTag_textAttribute('match', false, we_modules_info::CUSTOMER),
			new we_weTag_multiSelectorAttribute('userid', CUSTOMER_TABLE, '', 'ID', false),
			new we_weTag_selectAttribute('cfilter', we_weTag_selectAttribute::getTrueFalse(), false, we_modules_info::CUSTOMER),
			new we_weTag_selectAttribute('allowNoFilter', we_weTag_selectAttribute::getTrueFalse(), false, we_modules_info::CUSTOMER),
			new we_weTag_selectAttribute('matchType', [new we_weTag_option('one'),
				new we_weTag_option('contains'),
				new we_weTag_option('exact'),
				], false, we_modules_info::CUSTOMER),
		];
	}

}
