<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 4b60d5f6a53a $
 * $Author: mokraemer $
 * $Date: 2019-06-14 11:06 +0200 $
 */
class we_tw_ifVar extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_IF];
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$this->Attributes = [
			new we_weTag_textAttribute('name', true, ''),
			new we_weTag_textAttribute('match', true, ''),
			new we_weTag_selectAttribute('type', [
				new we_weTag_option('global'),
				new we_weTag_option('request'),
				new we_weTag_option('post'),
				new we_weTag_option('get'),
				new we_weTag_option('cookie'),
				new we_weTag_option('document'),
				new we_weTag_option('property'),
				new we_weTag_option('session'),
				new we_weTag_option('sessionfield'),
				], false, ''),
			new we_weTag_selectAttribute('doc', [
				new we_weTag_option('self'),
				new we_weTag_option('top'),
				], false, ''),
			new we_weTag_selectAttribute('operator', [
				new we_weTag_option('equal'),
				new we_weTag_option('less'),
				new we_weTag_option('less|equal'),
				new we_weTag_option('greater'),
				new we_weTag_option('greater|equal'),
				new we_weTag_option('contains'),
				new we_weTag_option('isin'),
				], false, ''),
		];
	}

}
