<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 */
class we_tw_navigationEntry extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = true;
		$this->Groups = [self::GROUP_NAVIGATION];
		$this->Module = we_modules_info::NAVIGATION;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);
		$this->DefaultValue = '<we:navigationField complete="link"/><br/>';

		$this->Attributes = [
			new we_weTag_textAttribute('navigationname', false, ''),
			new we_weTag_selectAttribute('type', [
				new we_weTag_option(we_weTag_selectorAttribute::FOLDER),
				new we_weTag_option('item'),
				], true, ''),
			new we_weTag_textAttribute('level', false, ''),
			new we_weTag_selectAttribute('current', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_choiceAttribute('position', [
				new we_weTag_option('first'),
				new we_weTag_option('odd'),
				new we_weTag_option('even'),
				new we_weTag_option('last'),
				], false, false, ''),
		];
	}

}
