<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 4e4ff85098e9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-03 00:26 +0200 $
 */
class we_tw_setVar extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName);
		$this->NeedsEndTag = false;
		$this->Description = g_l('weTag', '[' . $tagName . '][description]', true, true);

		$this->Attributes = [
			new we_weTag_textAttribute('value', false, ''),
			new we_weTag_selectAttribute('from', [
				new we_weTag_option('request'),
				new we_weTag_option('post'),
				new we_weTag_option('get'),
				new we_weTag_option('global'),
				new we_weTag_option('session'),
				new we_weTag_option('top'),
				new we_weTag_option('self'),
				new we_weTag_option('object'),
				new we_weTag_option('document'),
				new we_weTag_option('sessionfield'),
				new we_weTag_option('calendar'),
				new we_weTag_option('listview'),
				new we_weTag_option('block'),
				new we_weTag_option('listdir'),
				], false, ''),
			new we_weTag_textAttribute('namefrom', false, ''),
			new we_weTag_selectAttribute('typefrom', [
				new we_weTag_option('audio'),
				new we_weTag_option('binary'),
				new we_weTag_option('date'),
				new we_weTag_option('float'),
				new we_weTag_option('href'),
				new we_weTag_option('img'),
				new we_weTag_option('int'),
				new we_weTag_option('link'),
				new we_weTag_option('select'),
				new we_weTag_option('text'),
				new we_weTag_option('video'),
				], false, ''),
			new we_weTag_selectAttribute('propertyto', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('propertyfrom', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_textAttribute('formnameto', false, ''),
			new we_weTag_textAttribute('formnamefrom', false, ''),
			new we_weTag_selectAttribute('varType', [
				new we_weTag_option(we_base_request::STRING),
				new we_weTag_option(we_base_request::INT),
				new we_weTag_option(we_base_request::BOOL),
				new we_weTag_option(we_base_request::FLOAT),
				new we_weTag_option(we_base_request::EMAIL),
				new we_weTag_option(we_base_request::URL),
				new we_weTag_option(we_base_request::RAW),
				], false, ''),
			new we_weTag_selectAttribute('prepareSQL', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectAttribute('striptags', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_textAttribute('outputlanguage', false, ''),
		];
	}

}
