/* global top, WE */

/**
 * webEdition CMS
 *
 * webEdition CMS
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

function we_cmd() {
	/*jshint validthis:true */
	var caller = (this && this.window === this ? this : window),
		args = WE().util.getWe_cmdArgsArray(Array.prototype.slice.call(arguments)),
		url = WE().util.getWe_cmdArgsUrl(args);

	switch (args[0]) {
		case 'customValidationService':
			var service = '';
			var formdata = '';

			switch (args[1]) {
				case 'saveService':
				case 'deleteService':
					var form = WE().util.dialogTop(window).document.we_form;
					var params = [];
					for (var i = 0; i < form.length; i++) {
						switch (form[i].type) {
							case 'text':
							case 'select':
							case 'hidden':
							case 'select-one':
								params.push(form[i].name + '=' + form[i].value);
						}
					}
					formdata = params.join('&');
					/* falls through */
				case 'selectService':
					service = window.document.we_form.validationService.value;
					break;
				case 'newService':
				case 'firstService':
					break;
			}

			WE().util.rpc(WE().consts.dirs.WEBEDITION_DIR + 'rpc.php?mod=validation&cmd=' + args[1] + '&validationService=' + service, formdata, function (weResponse) {
				var opts = weResponse.DataArray.services;
				var sel = window.document.we_form.validationService;
				var option = null;
				var data = weResponse.DataArray.data;
				var message = weResponse.DataArray.message;

				sel.innerHTML = '';
				if (Object.keys(opts).length > 0) {
					WE().util.dialogTop(window).document.getElementById('dataTable').style.display = 'block';
					WE().util.dialogTop(window).document.getElementsByClassName('weBtnDelete')[0].disabled = false;
					for (var opt in opts) {
						if (opts.hasOwnProperty(opt)) {
							option = document.createElement('option');
							option.value = opt;
							option.text = opts[opt];
							sel.add(option);
						}
					}
					if (weResponse.DataArray.selected) {
						sel.value = weResponse.DataArray.selected;
					} else {
						sel.selectedIndex = 0;
					}
				} else {
					WE().util.dialogTop(window).document.getElementById('dataTable').style.display = 'none';
					WE().util.dialogTop(window).document.getElementsByClassName('weBtnDelete')[0].disabled = true;
				}
				if (data && data.id !== undefined) {
					for (var prop in data) {
						if (data.hasOwnProperty(prop) && window.document.we_form.elements[prop]) {
							window.document.we_form.elements[prop].value = data[prop];
						}
					}
				}
				if (message && message.text) {
					WE().util.showMessage(message.text, message.type, WE().util.dialogTop(window));
				}
			});
			break;
		case 'initDialog':
			we_cmd('customValidationService', 'firstService');
			break;
		case "close":
			WE().util.dialogTop(window).doClose();
			break;
		default :
			WE().util.dialogTop(window).opener.we_cmd.apply(caller, Array.prototype.slice.call(arguments));
			break;
	}
}
