/* global WE, top,weCombobox, prefs */

/**
 * webEdition CMS
 *
 * webEdition CMS
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';
var widget = WE().util.getDynamicVar(document, 'loadVarWidget', 'data-widget');
var _oCsv_,
	_sInitCsv_,
	_sInitTitle,
	_sInitBin,
	_sPadInc = 'pad/pad',
	_oSctDate,
	_aRdo = ['sort', 'display', 'date', 'prio'],
	_lastPreviewCsv = '',
	//_sCls_ = getCls(),
	_ttlB64Esc = encodeURIComponent(window.btoa(widget.sTb));

function weEntity2char(weString) {
	return weString.replace('&lt;', '<').replace('&gt;', '>');
}

function weChar2entity(weString) {
	return weString.replace('<', '&lt;').replace('>', '&gt;');
}

function getCls() {
	return WE().layout.cockpitFrame.document.getElementById(widget.sObjId + '_cls').value;
}
// displays the note dialog on click on a note
function selectNote(id) {
	var fo = document.forms[0];
	if (!isHotNote()) {
		cancelNote();
		setColor(document.getElementById(id + '_tr'), id, '#EDEDED');
		fo.elements.mark.value = id;
		populate(id);
	}
}
// displays the note dialog on click the add note button
function displayNote() {
	document.getElementById('view').style.display = 'none';
	document.getElementById('notices').style.height = '90px';
	document.getElementById('props').style.display = 'block';
	toggleTblValidity();
}
//close a open note
function cancelNote() {
	var fo = document.forms[0];
	document.getElementById('props').style.display = 'none';
	document.getElementById('notices').style.height = '250px';
	document.getElementById('view').style.display = 'block';
	var oMark = fo.elements.mark;
	var mark = oMark.value;
	if (mark !== '') {
		oMark.value = '';
		setColor(document.getElementById(mark + '_tr'), mark, '#FFFFFF');
	}
	unpopulate();
	WE().layout.button.switch_button_state(document, 'delete', 'disabled');
}
// deletes a note
function deleteNote() {
	var fo = document.forms[0];
	var mark = fo.elements.mark.value;
	var data = JSON.parse(window.atob(document.getElementById('notepadData[' + mark + ']').value));
	WE().layout.cockpitFrame.rpc('pad', _ttlB64Esc.concat(',' + widget.sInitProps), data.ID, 'delete', '', _ttlB64Esc, widget.sObjId);
}

function isHotNote() {
	var fo = document.forms[0];
	var _id = fo.elements.mark.value;
	if (_id === '') {
		return false;
	}
	var q_init = getInitialQueryById(_id);

	var q_curr = getCurrentQuery();
	var idx = ['Title', 'Text', 'Priority', 'Validity', 'ValidFrom', 'ValidUntil'];
	var idx_len = idx.length;
	for (var i = 0; i < idx_len; i++) {
		if (q_init[idx[i]] != q_curr[idx[i]]) {
			return true;
		}
	}
	return false;
}

function getInitialQueryById(id) {
	var data = JSON.parse(window.atob(document.getElementById('notepadData[' + id + ']').value));
	return {
		Validity: data.Valid,
		ValidFrom: data.ValidFrom,
		ValidUntil: data.ValidUntil,
		Priority: data.Priority,
		Title: data.Title,
		Text: data.Text
	};
}

function getCurrentQuery() {
	var fo = document.forms[0].elements;
	var oSctValid = fo.sct_valid;
	var validSel = oSctValid.options[oSctValid.selectedIndex].value;
	var oRdoPrio = fo.rdo_prio;
	var sValidFrom = fo.f_ValidFrom.value;
	var sValidUntil = fo.f_ValidUntil.value;
	return {
		Validity: (validSel === "0") ? 'always' : ((validSel === "1") ? 'date' : 'period'),
		ValidFrom: convertDate(sValidFrom, '%Y-%m-%d'),
		ValidUntil: convertDate(sValidUntil, '%Y-%m-%d'),
		Priority: (oRdoPrio[0].checked) ? 'high' : (oRdoPrio[1].checked) ? 'medium' : 'low',
		Title: fo.props_title.value,
		Text: fo.props_text.value
	};
}

function populate(r) {
	var fo = document.forms[0],
		data = JSON.parse(window.atob(document.getElementById('notepadData[' + r + ']').value));
	var sValidityIndex = data.Valid === 'always' ? 0 : (data.Valid === 'date' ? 1 : 2);
	var oSctValid = fo.elements.sct_valid;
	var iSctValidLen = oSctValid.length;
	for (var i = iSctValidLen - 1; i >= 0; i--) {
		if (oSctValid.options[i].value == sValidityIndex) {
			oSctValid.options[i].selected = true;
			break;
		}
	}
	toggleTblValidity();
	fo.elements.f_ValidFrom.value = convertDate(data.ValidFrom, '%d.%m.%Y');
	fo.elements.f_ValidUntil.value = convertDate(data.ValidUntil, '%d.%m.%Y');
	fo.elements.rdo_prio[data.Priority === 'high' ? 0 : data.Priority === 'medium' ? 1 : 2].checked = true;
	fo.elements.props_title.value = data.Title;
	fo.elements.props_text.value = data.Text;
	WE().layout.button.switch_button_state(document, 'delete', 'enabled');
	displayNote();
}

function unpopulate() {
	var fo = document.forms[0];
	var oSctValid = fo.elements.sct_valid;
	oSctValid.options[0].selected = true;
	fo.elements.f_ValidFrom.value = '';
	fo.elements.f_ValidUntil.value = '';
	fo.elements.rdo_prio[2].checked = true;
	fo.elements.props_title.value = '';
	fo.elements.props_text.value = '';
}

function setColor(theRow, theRowNum, newColor) {
	var fo = document.forms[0],
		theCells;
	if (fo.elements.mark.value !== '' || theRow.style === undefined) {
		return false;
	}
	theCells = theRow.getElementsByTagName('td');
	var rowCellsCnt = theCells.length;
	var domDetect = (window.opera === undefined && theCells[0].getAttribute !== undefined);
	var c = null;
	if (domDetect) {
		for (c = 0; c < rowCellsCnt; c++) {
			theCells[c].setAttribute('bgcolor', newColor, 0);
		}
	} else {
		for (c = 0; c < rowCellsCnt; c++) {
			theCells[c].style.backgroundColor = newColor;
		}
	}
	return true;
}

function convertDate(sDate, sFormat) {
	var fixedImplode = '';
	var arr = sDate.split((sFormat === '%Y-%m-%d') ? '.' : '-');
	var separator = (sFormat === '%Y-%m-%d') ? '-' : '.';
	for (var x = arr.length - 1; x >= 0; x--) {
		fixedImplode += (separator + arr[x].toString());
	}
	fixedImplode = fixedImplode.substring(separator.length, fixedImplode.length);
	return fixedImplode;
}

function toggleTblValidity() {
	switch (getCurrentQuery().Validity) {
		case "always":
			document.getElementById("f_ValidFrom_cell").style.visibility = "hidden";
			document.getElementById("f_ValidUntil_cell").style.visibility = "hidden";
			break;
		case "date":
			document.getElementById("f_ValidFrom_cell").style.visibility = "visible";
			document.getElementById("f_ValidUntil_cell").style.visibility = "hidden";
			break;
		default:
			document.getElementById("f_ValidFrom_cell").style.visibility = "visible";
			document.getElementById("f_ValidUntil_cell").style.visibility = "visible";
	}
}

// saves a note, using the function rpc() in home.inc.php (750)
function saveNote() {
	var fo = document.forms[0],
		_id = fo.elements.mark.value,
		weValidFrom, weValidUntil;
	var q_init = (_id !== '' ?
		getInitialQueryById(_id) :
		{Validity: 'always', ValidFrom: '', ValidUntil: '', Priority: 'low', Title: '', Text: ''});
	var q_curr = getCurrentQuery();
	var hot = false;
	var idx = ['Title', 'Text', 'Priority', 'Validity', 'ValidFrom', 'ValidUntil'];
	var csv = '';
	var idx_len = idx.length;
	for (var i = 0; i < idx_len; i++) {
		if (q_init[idx[i]] != q_curr[idx[i]]) {
			hot = true;
		}
		csv += (idx[i] === 'Title' || idx[i] === 'Text') ? window.btoa(q_curr[idx[i]]) : q_curr[idx[i]];
		if (i < idx_len - 1) {
			csv += ';';
		}
	}

	if (_id !== '') {
		if (hot) {
			// update note

			if (q_curr.Validity === 'period') {
				weValidFrom = q_curr.ValidFrom.replace(/-/g, '');
				weValidUntil = q_curr.ValidUntil.replace(/-/g, '');
				if (weValidFrom > weValidUntil) {
					WE().util.showMessage(WE().consts.g_l.cockpit.pad.until_befor_from, WE().consts.message.WE_MESSAGE_NOTICE, window);
					return false;
				}
			}
			if (q_curr.Title === '') {
				WE().util.showMessage(WE().consts.g_l.cockpit.pad.title_empty, WE().consts.message.WE_MESSAGE_NOTICE, window);
				return false;
			}
			var data = JSON.parse(window.atob(document.getElementById('notepadData[' + _id + ']').value));
			WE().layout.cockpitFrame.rpc('pad', _ttlB64Esc.concat(',' + widget.sInitProps), (data.ID + ';' + encodeURI(csv)), 'update', '', _ttlB64Esc, widget.sObjId, 'pad/pad', q_curr.Title, q_curr.Text);
		} else {
			WE().util.showMessage(WE().consts.g_l.cockpit.pad.note_not_modified, WE().consts.message.WE_MESSAGE_NOTICE, window);
		}
		return;
	}
	if (hot) {
		// insert note
		if (q_curr.Validity === 'period') {
			weValidFrom = q_curr.ValidFrom.replace(/-/g, '');
			weValidUntil = q_curr.ValidUntil.replace(/-/g, '');
			if (weValidFrom > weValidUntil) {
				WE().util.showMessage(WE().consts.g_l.cockpit.pad.until_befor_from, WE().consts.message.WE_MESSAGE_NOTICE, window);
				return false;
			} else if (!weValidFrom || !weValidUntil) {
				WE().util.showMessage(WE().consts.g_l.cockpit.pad.date_empty, WE().consts.message.WE_MESSAGE_ERROR, window);
				return false;
			}
		} else if (q_curr.Validity === 'date' && !q_curr.ValidFrom) {
			WE().util.showMessage(WE().consts.g_l.cockpit.pad.date_empty, WE().consts.message.WE_MESSAGE_NOTICE, window);
			return false;
		}
		if (q_curr.Title === '') {
			WE().util.showMessage(WE().consts.g_l.cockpit.pad.title_empty, WE().consts.message.WE_MESSAGE_NOTICE, window);
			return false;
		}
		WE().layout.cockpitFrame.rpc('pad', _ttlB64Esc.concat(',' + widget.sInitProps), csv, 'insert', '', _ttlB64Esc, widget.sObjId, 'pad/pad', q_curr.Title, q_curr.Text);
	} else {
		WE().util.showMessage(WE().consts.g_l.cockpit.pad.title_empty, WE().consts.message.WE_MESSAGE_NOTICE, window);
	}
}

function initDlg() {
	var _fo = document.forms[0];
	_oCsv_ = WE().util.dialogTop(window).opener.document.getElementById(prefs._sObjId + '_csv');
	_sInitCsv_ = _oCsv_.value;
	var aCsv = _sInitCsv_.split(',');
	_sInitTitle = window.atob(aCsv[0]);
	_sInitBin = aCsv[1];
	var i;
	for (i = 0; i < _aRdo.length; i++) {
		_fo.elements['rdo_' + _aRdo[i]][_sInitBin.charAt(i)].checked = true;
	}
	_fo.elements.sct_valid.options[_sInitBin.charAt(4)].selected = true;
	var oSctTitle = _fo.elements.sct_title;
	for (i = oSctTitle.length - 1; i >= 0; i--) {
		oSctTitle.options[i].selected = (oSctTitle.options[i].text == _sInitTitle);
	}
	WE().util.dialogTop(window).initPrefs();
	var ComboBox = new weCombobox();
	ComboBox.init('title');
}

function getRdoChecked(sType) {
	var _fo = document.forms[0];
	var oRdo = _fo.elements['rdo_' + sType];
	var iRdoLen = oRdo.length;
	for (var i = 0; iRdoLen > i; i++) {
		if (oRdo[i].checked === true) {
			return i;
		}
	}
}

function getBitString() {
	var _fo = document.forms[0];
	var sBit = '';
	for (var i = 0; i < _aRdo.length; i++) {
		var iCurr = getRdoChecked(_aRdo[i]);
		sBit += (iCurr !== undefined) ? iCurr : '0';
	}
	sBit += _fo.elements.sct_valid.selectedIndex;
	return sBit;
}

function getTitle() {
	var _fo = document.forms[0];
	var oSctTitle = _fo.elements.sct_title;
	return oSctTitle[oSctTitle.selectedIndex].value;
}

function save() {
	var oCsv_ = WE().util.dialogTop(window).opener.document.getElementById(widget.sObjId + '_csv');
	var sTitleEnc = window.btoa(getTitle());
	var sBit = getBitString();

	oCsv_.value = sTitleEnc.concat(',' + sBit);
	if ((_lastPreviewCsv !== '' && sTitleEnc.concat(',' + sBit) !== _lastPreviewCsv) ||
		(_lastPreviewCsv === '' && (_sInitTitle != getTitle() || _sInitBin != getBitString()))) {
		WE().layout.cockpitFrame.rpc('pad', sTitleEnc.concat(',' + sBit), '', '', '', sTitleEnc, widget.sObjId);
	}
	WE().util.dialogTop(window).opener.setPrefs(widget.sObjId, sBit, sTitleEnc);
	WE().util.showMessage(WE().consts.g_l.main.prefs_saved_successfully, WE().consts.message.WE_MESSAGE_NOTICE, window);
	WE().layout.weNavigationHistory.navigateReload();
	WE().util.dialogTop(window).doClose();
}

function preview() {
	var sTitleEnc = window.btoa(getTitle());
	var sBit = getBitString();
	WE().layout.cockpitFrame.rpc('pad', sTitleEnc.concat(',' + sBit), '', '', '', sTitleEnc, prefs._sObjId);
	WE().util.dialogTop(window).previewPrefs();
	_lastPreviewCsv = sTitleEnc.concat(',' + sBit);
}

function exit_close() {
	if (_lastPreviewCsv !== '' && (_sInitTitle != getTitle() || _sInitBin != getBitString())) {
		WE().layout.cockpitFrame.rpc('pad', _sInitCsv_, '', '', '', window.btoa(_sInitTitle), prefs._sObjId);
	}
	WE().util.dialogTop(window).exitPrefs();
	WE().util.dialogTop(window).doClose();
}
