/* global WE, top */

/**
 *
 * webEdition CMS
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 *
 *  * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';


WE().util.jsWindow = function (opener, url, ref, w, h, scroll, resizable) {
	var foo_w = w,
		foo_h = h,
		max_width = window.outerWidth,
		max_height = window.outerHeight;

	if (WE(true) && WE().layout.mainFrame) {
		max_width = WE().layout.mainFrame.innerWidth;
		max_height = WE().layout.mainFrame.innerHeight;
	}
	w = Math.min(max_width, w);
	h = Math.min(max_height, h);

	this.opener = opener;
	this.referer = opener.top;
	this.url = url;
	this.ref = ref;
	this.x = Math.round((max_width - w) / 2);
	this.y = Math.round((max_height - h) / 2);
	this.w = w;
	this.h = h;
	this.scroll = (foo_w !== w || foo_h !== h) ? true : scroll;
	this.resizable = resizable;
	this.wind = null;

	/*if (overlay) {
		var tmp = new (WE().util.jsOverlay)(opener, target, url, ref, w, h);
		if (resizable) {
			tmp.setResizeable();
		}
		tmp.open();
		return tmp;
	}*/
	if (WE(true)) {
		WE().layout.windows = WE().layout.windows ? WE().layout.windows : [];
		WE().layout.windows.push(this);
	}
	this.open();
};

WE().util.jsWindow.prototype = {
	open: function () {
		var properties = "menubar=no," + (this.resizable ? "resizable=yes," : "resizable=no,") + ((this.scroll) ? "scrollbars=yes," : "scrollbars=no,") + "width=" + this.w + ",height=" + this.h + ",left=" + this.x + ",top=" + this.y;
		try {
			this.wind = this.opener.open(this.url, this.ref, properties);
			this.wind.focus();

		} catch (e) {
		}

	},
	close: function () {
		var wind;
		for (var i = 0; i < WE().layout.windows.length; i++) {
			wind = WE().layout.windows[i].wind;
			if (!wind || wind === this.wind || wind === undefined || wind.closed) {
				WE().layout.windows.splice(i, 1);
				i--;
			}
		}
		if (!this.wind.closed) {
			this.wind.close();
		}
	},
	doClose: function () {
		this.close();
	},
	closeByName: function (name) {
		var obj;
		while ((obj = this.find(name))) {
			//closes dependend windows
			this.closeAll(obj.wind);
		}
	},
//FIXME:this function should be called instead of a top.close
	closeAll: function (ref) {
		if (ref === undefined || ref === null) {
			while (WE().layout.windows.length) {
				WE().layout.windows.pop().close();
			}
		} else {
			var refObj;
			for (var i = 0; i < WE().layout.windows.length; i++) {
				if (!WE().layout.windows[i] || WE().layout.windows[i] === undefined || WE().layout.windows[i].wind === undefined) {
					//remove from window list
					WE().layout.windows.splice(i, 1);
					//reset i
					i = -1;
					continue;
				}
				if (WE().layout.windows[i].wind === ref) {
					refObj = WE().layout.windows[i];
				}
				if (WE().layout.windows[i].referer === ref) {
					var obj = WE().layout.windows[i];
					//remove from window list
					WE().layout.windows.splice(i, 1);
					//close all windows from this window first
					this.closeAll(obj.wind);
					obj.close();
					//reset i
					i = -1;
				}
			}
			if (refObj) {
				refObj.close();
			} else if (!ref.closed) {
				//if we didn't find the window, just close it
				ref.close();
			}
		}
	},
	find: function (name) {
		for (var i = 0; i < WE().layout.windows.length; i++) {
			if (WE().layout.windows[i].ref === name) {
				return WE().layout.windows[i].wind;
			}
		}
		return undefined;
	},
	focus: function (name) {
		var wind = this.find(name);
		if (wind !== undefined) {
			wind.focus();
			return true;
		}
		return false;
	}
};