/* global tinymce */

/**
 * webEdition CMS
 *
 * $Author: Lukas Imhof $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

(function () {
	var wepastetext = (function () {
		var global = tinymce.util.Tools.resolve('tinymce.PluginManager');
		var Buttons = {register: function (editor) {
				editor.ui.registry.addToggleButton('wepastetext', {
					icon: 'paste-text',
					tooltip: 'Paste as text',
					onAction: function () {
						editor.execCommand('mceTogglePlainTextPaste');
						editor.weControlManager.setActive('wepastetext', editor.plugins.paste.clipboard.pasteFormat.get() === 'text');
					},
					onSetup: function (buttonApi) {
						editor.weControlManager.register('button', 'wepastetext', buttonApi);
						buttonApi.setActive(true);
					}
				});
			}};

		global.add('wepastetext', function (editor) {
			Buttons.register(editor);
			return {};
		});

		function Plugin() {}

		return Plugin;
	}());
})();